library(data.table)

###############################################################
# We use this code to generate the configuration worksheet of the SST-Template
###############################################################

# Rows where the styles should be applied (row1 = start, row2 = end)
commentStyle <- data.table(row1 = c(9, 13, 18, 48, 66, 69, 91, 94, 102, 116, 123, 142, 161, 173, 187, 202, 210, 224), row2 = c(10, 13, 45 , 64, 66, 89, 91, 99, 113, 120, 139, 158, 170, 184, 199, 207, 221, 227))
headerStyle <- data.table(row = c(16, 17, 47, 68, 93, 101, 115, 122, 141, 160, 172, 186, 201, 209, 223))
boldStyle <- data.table(row = c(18, 22, 25, 28, 38, 42, 45, 48, 51, 61, 66, 83, 91, 99))
lightGridStyle <- data.table(row1 = c(18, 48, 66, 69, 91, 94, 102, 115, 123, 142, 161, 173, 187, 202, 210, 224), row2 = c(45 , 64, 66, 89, 91, 99, 113, 120, 139, 158, 170, 184, 199, 207, 221, 227))

# Entries in the FDS
FDSLabel <- fread('"col","row","field"
                  2,1,"Fundamental-Data-Sheet (FDS)"
                  4,5,"in Mio. CHF"
                  2,8,"Allgemeine Informationen"
                  2,9,"Name der Versicherungsgesellschaft"
                  2,10,"Sparte"
                  2,12,"SST-Währung bzw. Währungskorb"
                  2,13,"SST-Währung bzw. Währungskorb"
                  2,14,"Wechselkurs (SST-Währung bzw. Währungskorb gegenüber CHF)"
                  2,16,"SST-Bilanz"
                  2,17,"Kapitalanlagen"
                  2,18,"Immobilien"
                  2,19,"Beteiligungen"
                  2,20,"Beteiligungen: Quote > 50 %"
                  2,21,"Beteiligungen: Quote 20 % bis 50 %"
                  2,22,"Festverzinsliche Wertpapiere"
                  2,23,"davon Staats- und Zentralbankenanleihen"
                  2,24,"davon Unternehmensanleihen"
                  2,25,"Darlehen"
                  2,26,"davon nachrangige Darlehen"
                  2,27,"davon Policendarlehen"
                  2,28,"Hypotheken"
                  2,29,"Aktien"
                  2,30,"Übrige Kapitalanlagen"
                  2,31,"Kollektive Kapitalanlagen"
                  2,32,"Anlagefonds: Immobilien"
                  2,33,"Anlagefonds: Aktien"
                  2,34,"Anlagefonds: festverzinsliche Wertpapiere"
                  2,35,"Anlagefonds: Geldmarkt"
                  2,36,"Anlagefonds: Übrige"
                  2,37,"Anlagefonds: Gemischt"
                  2,38,"Alternative Kapitalanlagen"
                  2,39,"davon Hedgefonds"
                  2,40,"davon Private Equity"
                  2,41,"davon Rohstoffe"
                  2,42,"Strukturierte Produkte"
                  2,43,"Sonstige Kapitalanlagen"
                  2,44,"davon verbriefte Forderungen"
                  2,45,"Total Kapitalanlagen"
                  2,47,"übrige Aktiven"
                  2,48,"Kapitalanlagen aus anteilgebundener Lebensversicherung"
                  2,49,"Fondsanteilgebundene Lebensversicherung"
                  2,50,"An interne Anlagebestände oder andere Bezugswerte gebundene Lebensversicherung"
                  2,51,"Forderungen aus derivativen Finanzinstrumenten"
                  2,52,"Flüssige Mittel"
                  2,53,"Anteil versicherungstechnische Rückstellungen aus Rückversicherung"
                  2,54,"Direktversicherung: Lebensversicherungsgeschäft (ohne ALV)"
                  2,55,"Direktversicherung: Schadenversicherungsgeschäft"
                  2,56,"Direktversicherung: Krankenversicherungsgeschäft"
                  2,57,"Direktversicherung: Sonstiges Geschäft"
                  2,58,"Direktversicherung: Anteilgebundenes Lebensversicherungsgeschäft"
                  2,59,"davon Überschussfonds"
                  2,60,"Aktive Rückversicherung (Retrozessionen) - indirektes Geschäft"
                  2,61,"Forderungen aus dem Versicherungsgeschäft inkl. Depotforderungen"
                  2,62,"Übrige Forderungen"
                  2,63,"Andere Aktiven"
                  2,64,"Total übrige Aktiven"
                  2,66,"Total Aktiven"
                  2,68,"Best Estimate des Fremdkapitals"
                  2,69,"Best Estimate der Versicherungsverpflichtungen (Leben): Brutto inkl. anteilgebundene Lebensversicherung"
                  2,70,"davon Einzelgeschäft"
                  2,71,"davon Kollektivgeschäft"
                  2,72,"davon anteilgebundene Lebensversicherung"
                  2,73,"Rückstellungen für vertragliche Überschussbeteiligungen (Leben): Brutto"
                  2,74,"Best Estimate der Versicherungsverpflichtungen (Schaden): Brutto"
                  2,75,"Rückstellungen für vertragliche Überschussbeteiligungen (Schaden): Brutto"
                  2,76,"Best Estimate der Versicherungsverpflichtungen (Kranken): Brutto"
                  2,77,"Best Estimate der Langzeitverpflichtungen (Kranken): Brutto"
                  2,78,"Rückstellungen für vertragliche Überschussbeteiligungen (Kranken): Brutto"
                  2,79,"Best Estimate der sonstigen Versicherungsverpflichtungen"
                  2,80,"Rückstellungen für Überschussfonds"
                  2,81,"Direktversicherung: Sonstiges Geschäft"
                  2,82,"Aktive Rückversicherung (indirektes Geschäft)"
                  2,83,"Nichtversicherungstechnische Rückstellungen"
                  2,84,"Verzinsliche Verbindlichkeiten"
                  2,85,"Verbindlichkeiten aus derivativen Finanzinstrumenten"
                  2,86,"Depotverbindlichkeiten aus abgegebener Rückversicherung"
                  2,87,"Verbindlichkeiten aus dem Versicherungsgeschäft"
                  2,88,"Nachrangige Verbindlichkeiten"
                  2,89,"Andere Verbindlichkeiten"
                  2,91,"Total Best-Estimate des Fremdkapitals"
                  2,93,"Risikotragendes Kapital"
                  2,94,"Differenz marktnaher Wert Aktiven und Best Estimate der Verpflichtungen"
                  2,95,"Abzüge"
                  2,96,"Kernkapital"
                  2,97,"Ergänzendes Kapital"
                  2,98,"Zusätzliches Kapital"
                  2,99,"RTK"
                  2,101,"Hauptergebnisse"
                  2,102,"Erwartetes versicherungstechnisches Ergebnis"
                  2,103,"Erwartetes finanzielles Ergebnis über risikofrei"
                  2,104,"1-jahres Kreditrisiko"
                  2,105,"1-jahres Marktrisiko (zentriert)"
                  2,106,"1-jahres versicherungstechnisches Risiko (zentriert)"
                  2,107,"Diversifikationseffekt"
                  2,108,"Effekt der Szenarien auf das Zielkapital"
                  2,109,"Effekt der LLPO auf das Zielkapital (nur für Beteiligungsmodell)"
                  2,110,"Market Value Margin"
                  2,111,"Zusätzliche Effekte auf Zielkapital"
                  2,112,"Zielkapital"
                  2,113,"SST-Quotient"
                  2,115,"Im aktuellen Jahr erwartete Werte"
                  2,116,"Erwartete brutto Prämien (vor Rückversicherung)"
                  2,117,"Erwartete netto Prämien (nach Rückversicherung)"
                  2,118,"Erwartete brutto Jahresschäden (vor Rückversicherung)"
                  2,119,"Erwartete netto Jahresschäden (nach Rückversicherung)"
                  2,120,"Erwartete Kosten"
                  2,122,"Marktrisiko (Expected Shortfall Werte)"
                  2,123,"Marktrisiko (alle Risikofaktoren)"
                  2,124,"Diversifikationseffekte Marktrisiko"
                  2,125,"Marktrisiko der Zinsen"
                  2,126,"davon Marktrisiko der Zinsen in CHF"
                  2,127,"davon Marktrisiko der Zinsen in EUR"
                  2,128,"davon Marktrisiko der Zinsen in USD"
                  2,129,"davon Marktrisiko der Zinsen in GBP"
                  2,130,"Marktrisiko der Spreads"
                  2,131,"Marktrisiko der Währungskurse"
                  2,132,"Marktrisiko der Aktien"
                  2,133,"Marktrisiko der Immobilien"
                  2,134,"Marktrisiko der Hedgefonds"
                  2,135,"Marktrisiko der Private Equity"
                  2,136,"Marktrisiko der Beteiligungen"
                  2,137,"Marktrisiko (andere)"
                  2,138,"Weitere Marktrisiken 1"
                  2,139,"Weitere Marktrisiken 2"
                  2,141,"Szenarien"
                  2,142,"S1.1 Brexit / Euroraumkrise"
                  2,143,"S1.2 Weltweite Rezession"
                  2,144,"S1.3 Weltweite Depression"
                  2,145,"S1.4 Immobilienkrise in der Schweiz"
                  2,146,"S2.1 Ausfall der Rückversicherer"
                  2,147,"S3.1 Langlebigkeit"
                  2,148,"S3.2 Invalidität"
                  2,149,"S3.3 Storno"
                  2,150,"S3.4 Panik im Stadion"
                  2,151,"S3.5 Industrieunfall"
                  2,152,"S3.6 Betriebsausflug"
                  2,153,"S3.7 Unterreservierung"
                  2,154,"S4.1 Financial Distress"
                  2,155,"S4.2 Pandemie"
                  2,156,"U1.1 Terrorismus"
                  2,157,"U1.2 Immobilienkonzentration"
                  2,158,"U1.3 Konzentrationsszenario"
                  2,160,"Versicherungstechnisches Risiko: Lebensgeschäft (Expected-Shortfall, inkl. Zufalls- und Parameterrisiko)"
                  2,161,"Total (übriges Geschäft und Kollektivgeschäft)"
                  2,162,"Sterblichkeit (q)"
                  2,163,"Langlebigkeit (lambda)"
                  2,164,"Invalidität"
                  2,165,"Reaktivierungsrate"
                  2,166,"Übriges Geschäft: Kosten"
                  2,167,"Übriges Geschäft: Storno"
                  2,168,"Optionsausübung"
                  2,169,"Kollektivgeschäft: Kosten"
                  2,170,"Kollektivgeschäft: Storno"
                  2,172,"Versicherungstechnisches Risiko: Schadengeschäft (Expected-Shortfall, inkl. Zufalls- und Parameterrisiko)"
                  2,173,"Total 1-jahres versicherungstechnisches Risiko Schadengeschäft (zentriert)"
                  2,174,"Rückstellungsrisiko"
                  2,175,"Diskontierter erwarteter Schadenaufwand Normalschäden"
                  2,176,"Diskontierter erwarteter Schadenaufwand Grossschäden exkl. Naturkatastrophen"
                  2,177,"Diskontierter erwarteter Schadenaufwand Naturkatastrophen"
                  2,178,"Zentriertes Neuschadenrisiko"
                  2,179,"davon zentriertes Neuschadenrisiko Normalschäden"
                  2,180,"davon zentriertes Neuschadenrisiko Grossschäden exkl. Naturkatastrophen"
                  2,181,"davon zentriertes Neuschadenrisiko Naturkatastrophen"
                  2,182,"Weitere versicherungstechnische Risiken aus dem Schadengeschäft (zentriert)"
                  2,183,"Variationskoeffizient der Rückstellungsrisiken"
                  2,184,"Variationskoeffizient der Neuschadenrisiken Normalschäden"
                  2,186,"Versicherungstechnisches Risiko: Krankenversicherung (Expected-Shortfall und erwartete Werte)"
                  2,187,"Total 1-jahres versicherungstechnisches Risiko Krankengeschäft (zentriert)"
                  2,188,"Total 1-jahres versicherungstechnisches Risiko Krankengeschäft (zentriert, ohne Szenarien)"
                  2,189,"Versicherungsrisiko Einzelkranken: Total"
                  2,190,"Versicherungsrisiko Einzelkranken: LZV-Risiko"
                  2,191,"davon Sterblichkeit"
                  2,192,"davon Storno"
                  2,193,"davon Verwaltungskosten"
                  2,194,"davon Leistungen"
                  2,195,"Versicherungsrisiko Einzelkranken: CY-Risiko"
                  2,196,"Versicherungsrisiko Kollektivtaggeld"
                  2,197,"Kollektivtaggeld: Erwartete Prämien (brutto)"
                  2,198,"Kollektivtaggeld: Erwartete Leistungen (brutto)"
                  2,199,"Einzelkranken: Anzahl Versicherte (Kopfzählung)"
                  2,201,"Kreditrisiko"
                  2,202,"Kreditrisiko"
                  2,203,"Kreditrisiko der Hypotheken und non-agency Verbriefungen"
                  2,204,"Kreditrisiko des Resttermes"
                  2,205,"Kreditrisiko aus dem stochastischen Modell"
                  2,206,"davon Defaultrisiko"
                  2,207,"davon Migrationsrisiko"
                  2,209,"Festverzinsliche Wertpapiere: Ratingaufteilung"
                  2,210,"Staatsanleihen AA- und höher"
                  2,211,"Staatsanleihen A- bis und mit A+"
                  2,212,"Staatsanleihen BBB- bis und mit BBB+"
                  2,213,"Staatsanleihen tiefer als BBB- und kein Rating"
                  2,214,"Unternehmensanleihen AA- und höher"
                  2,215,"Unternehmensanleihen A- bis und mit A+"
                  2,216,"Unternehmensanleihen BBB- bis und mit BBB+"
                  2,217,"Unternehmensanleihen tiefer als BBB- und kein Rating"
                  2,218,"Sonstige Anleihen AA- und höher"
                  2,219,"Sonstige Anleihen A- bis und mit A+"
                  2,220,"Sonstige Anleihen BBB- bis und mit BBB+"
                  2,221,"Sonstige Anleihen tiefer als BBB- und kein Rating"
                  2,223,"Duration (Fisher-Weil)"
                  2,224,"Marktwert festverzinsliche Kapitalanlagen"
                  2,225,"Duration festverzinsliche Kapitalanlagen [Jahre]"
                  2,226,"Marktwert versicherungstechnische Verpflichtungen"
                  2,227,"Duration versicherungstechnische Verpflichtungen [Jahre]"
                  ')

# Values that will be exported to the FDS
FDSValues <- fread(
  "field,row,withFX
  RTK,99,1
  market.all,105,1
  insurance.all,106,1
  SSTRatio,113,0
  market.all,123,1
  market.diversification,124,1
  market.interest rate,125,1
  market.CHF rate,126,1
  market.EUR rate,127,1
  market.USD rate,128,1
  market.GBP rate,129,1
  market.spread,130,1
  market.currency,131,1
  market.equity,132,1
  market.real estate,133,1
  market.hedge fund,134,1
  market.private equity,135,1
  market.participation,136,1
  market.other,137,1
  market.additional1,138,1
  market.additional2,139,1
  nonlife.all,173,1
  life.all,161,1
  life.Mortality,162,1
  life.Longevity,163,1
  life.Disability,164,1
  life.Reactivation,165,1
  life.Costs,166,1
  life.Lapses,167,1
  life.Capital option,168,1
  life.Cost BVG,169,1
  life.Lapses BVG,170,1
  health.all,187,1
  health.all_beforeScenario,188,1
  health.Individual health,189,1
  health.Collective compensation,196,1
  expectedInsuranceResult,102,1
  expectedFinancialResult,103,1
  credit.all,104,1
  diversificationMarketInsuranceCredit,107,1
  scenarioImpact,108,1
  LLPOImpact,109,1
  MVM,110,1
  additionalEffectOnTC,111,1
  targetCapital,112,1
  credit.all,202,1
  credit.Basel.Hypothek,203,1
  credit.Basel.Rest,204,1
  credit.Merton.all,205,1
  credit.Merton.default,206,1
  credit.Merton.migration,207,1
  scenario.S1.1,142,1
  scenario.S1.2,143,1
  scenario.S1.3,144,1
  scenario.S1.4,145,1
  scenario.S2.1,146,1
  scenario.S3.1,147,1
  scenario.S3.2,148,1
  scenario.S3.3,149,1
  scenario.S3.4,150,1
  scenario.S3.5,151,1
  scenario.S3.6,152,1
  scenario.S3.7,153,1
  scenario.S4.1,154,1
  scenario.S4.2,155,1
  scenario.U1.1,156,1
  scenario.U1.2,157,1
  scenario.U1.3,158,1
  ")


# Values from the SST-Template that will be copied into the FDS
FDSImport <- fread('row,sheet,row1,col,withFX
                   18,SST Balance Sheet,8,7,1
                   19,SST Balance Sheet,19,7,1
                   20,SST Balance Sheet,20,7,1
                   21,SST Balance Sheet,24,7,1
                   22,SST Balance Sheet,28,7,1
                   23,SST Balance Sheet,29,7,1
                   24,SST Balance Sheet,32,7,1
                   25,SST Balance Sheet,38,7,1
                   26,SST Balance Sheet,39,7,1
                   27,SST Balance Sheet,40,7,1
                   28,SST Balance Sheet,43,7,1
                   29,SST Balance Sheet,51,7,1
                   30,SST Balance Sheet,56,7,1
                   31,SST Balance Sheet,57,7,1
                   32,SST Balance Sheet,58,7,1
                   33,SST Balance Sheet,59,7,1
                   34,SST Balance Sheet,60,7,1
                   35,SST Balance Sheet,61,7,1
                   36,SST Balance Sheet,62,7,1
                   37,SST Balance Sheet,63,7,1
                   38,SST Balance Sheet,65,7,1
                   39,SST Balance Sheet,66,7,1
                   40,SST Balance Sheet,67,7,1
                   41,SST Balance Sheet,73,7,1
                   42,SST Balance Sheet,75,7,1
                   43,SST Balance Sheet,79,7,1
                   44,SST Balance Sheet,80,7,1
                   45,SST Balance Sheet,89,7,1
                   48,SST Balance Sheet,93,7,1
                   49,SST Balance Sheet,94,7,1
                   50,SST Balance Sheet,96,7,1
                   51,SST Balance Sheet,106,7,1
                   52,SST Balance Sheet,116,7,1
                   53,SST Balance Sheet,121,7,1
                   54,SST Balance Sheet,122,7,1
                   55,SST Balance Sheet,125,7,1
                   56,SST Balance Sheet,127,7,1
                   57,SST Balance Sheet,131,7,1
                   58,SST Balance Sheet,133,7,1
                   59,SST Balance Sheet,123,7,1
                   59,SST Balance Sheet,126,7,1
                   59,SST Balance Sheet,128,7,1
                   60,SST Balance Sheet,124,7,1
                   60,SST Balance Sheet,129,7,1
                   60,SST Balance Sheet,130,7,1
                   60,SST Balance Sheet,132,7,1
                   60,SST Balance Sheet,134,7,1
                   61,SST Balance Sheet,114,7,1
                   61,SST Balance Sheet,144,7,1
                   62,SST Balance Sheet,153,7,1
                   63,SST Balance Sheet,136,7,1
                   63,SST Balance Sheet,140,7,1
                   63,SST Balance Sheet,142,7,1
                   63,SST Balance Sheet,155,7,1
                   63,SST Balance Sheet,159,7,1
                   63,SST Balance Sheet,161,7,1
                   64,SST Balance Sheet,167,7,1
                   66,SST Balance Sheet,169,7,1
                   69,SST Balance Sheet,209,7,1
                   69,SST Balance Sheet,211,7,1
                   69,SST Balance Sheet,213,7,1
                   69,SST Balance Sheet,176,7,1
                   69,SST Balance Sheet,177,7,1
                   70,SST Balance Sheet,176,7,1
                   71,SST Balance Sheet,177,7,1
                   72,SST Balance Sheet,209,7,1
                   72,SST Balance Sheet,211,7,1
                   72,SST Balance Sheet,213,7,1
                   73,SST Balance Sheet,181,7,1
                   74,SST Balance Sheet,186,7,1
                   75,SST Balance Sheet,190,7,1
                   76,SST Balance Sheet,195,7,1
                   77,SST Balance Sheet,198,7,1
                   78,SST Balance Sheet,201,7,1
                   79,SST Balance Sheet,179,7,1
                   79,SST Balance Sheet,189,7,1
                   79,SST Balance Sheet,200,7,1
                   80,SST Balance Sheet,182,7,1
                   80,SST Balance Sheet,191,7,1
                   80,SST Balance Sheet,202,7,1
                   81,SST Balance Sheet,205,7,1
                   82,SST Balance Sheet,183,7,1
                   82,SST Balance Sheet,192,7,1
                   82,SST Balance Sheet,203,7,1
                   82,SST Balance Sheet,206,7,1
                   82,SST Balance Sheet,214,7,1
                   83,SST Balance Sheet,216,7,1
                   84,SST Balance Sheet,221,7,1
                   85,SST Balance Sheet,223,7,1
                   86,SST Balance Sheet,231,7,1
                   87,SST Balance Sheet,233,7,1
                   88,SST Balance Sheet,245,7,1
                   89,SST Balance Sheet,237,7,1
                   89,SST Balance Sheet,241,7,1
                   91,SST Balance Sheet,252,7,1
                   94,RBC,7,5,1
                   95,RBC,16,5,1
                   96,RBC,18,5,1
                   97,RBC,30,5,1
                   98,RBC,35,5,1
                   116,Other Data,7,5,1
                   117,Other Data,8,5,1
                   118,Other Data,9,5,1
                   119,Other Data,10,5,1
                   120,Other Data,11,5,1
                   174,Other Data,15,5,1
                   175,Other Data,16,5,1
                   176,Other Data,17,5,1
                   177,Other Data,18,5,1
                   178,Other Data,19,5,1
                   179,Other Data,20,5,1
                   180,Other Data,21,5,1
                   181,Other Data,22,5,1
                   182,Other Data,23,5,1
                   183,Other Data,24,5,0
                   184,Other Data,25,5,0
                   190,Other Data,29,5,1
                   191,Other Data,30,5,1
                   192,Other Data,31,5,1
                   193,Other Data,32,5,1
                   194,Other Data,33,5,1
                   195,Other Data,34,5,1
                   197,Other Data,36,5,1
                   198,Other Data,37,5,1
                   199,Other Data,35,5,0
                   210,SST Balance Sheet,29,12,1
                   211,SST Balance Sheet,29,13,1
                   212,SST Balance Sheet,29,14,1
                   213,SST Balance Sheet,29,15,1
                   214,SST Balance Sheet,32,12,1
                   215,SST Balance Sheet,32,13,1
                   216,SST Balance Sheet,32,14,1
                   217,SST Balance Sheet,32,15,1
                   218,SST Balance Sheet,34,12,1
                   219,SST Balance Sheet,34,13,1
                   220,SST Balance Sheet,34,14,1
                   221,SST Balance Sheet,34,15,1
                   224,General Inputs,16,4,1
                   225,General Inputs,17,4,0
                   226,General Inputs,18,4,1
                   227,General Inputs,19,4,0
                   ')



# Standartized way to specify how a range from the SST-Template will be converted into a table
setTable <- function(keyword, description, sheet, row, isValue, columns, isEmptyAllowed = FALSE, isDropEmptyRows = FALSE, isCorrelation = FALSE){
  colParam = rbindlist(columns)
  setorder(colParam, "col")
  colParam[, ':=' (keyword = keyword, description = description, sheet = sheet, row = row, isValue = isValue, isEmptyAllowed = isEmptyAllowed, isDropEmptyRows = isDropEmptyRows, isCorrelation = isCorrelation)]
  return(colParam[])
}

# Standartized way to specify column parameters
setColumn <- function(name, col, type, isValueRequired = TRUE, isReplacementZero = FALSE, characteristic = NA, dataSelection = NA, warning = character(0), error = character(0), filterValue = NA){
  col <- col + seq_len(length(name)) - 1
  colParam <- data.table(name = as.character(name),
                         col = as.integer(col),
                         type = as.character(type),
                         isValueRequired = as.logical(isValueRequired),
                         isReplacementZero = as.logical(isReplacementZero),
                         characteristic = as.character(characteristic),
                         dataSelection = as.character(dataSelection),
                         filterValue = as.character(filterValue),
                         Warning = paste0(warning, collapse = ","),
                         Error = paste0(error, collapse = ",")
  )
  
  return(colParam)
}

# Configuration of all tables
TemplateConfig <- list(
  
  setTable(keyword = "correlationMarket",
           description = "correlation matrix",
           sheet = "Market (Dynamic)",
           row = 7,
           isValue = FALSE,
           isEmptyAllowed = TRUE,
           isCorrelation = TRUE,
           columns = list(
             setColumn(name = "name", col = 6, type = "Text", characteristic = "Primary key"),
             setColumn(name = paste0("RF", 1:100), col = 7, type = "Numeric")
           )
  )
  
  ,setTable(keyword = "configurationFDS",
            description = "FDS configuration",
            sheet = "Configuration",
            row = 3, #Row 2 contains the version ID
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            
            columns = list(
              setColumn(name = "action", col = 20, type = "Text"),
              setColumn(name = "row1", col = 21, type = "Integer"),
              setColumn(name = "row2", col = 22, type = "Integer", isValueRequired = FALSE),
              setColumn(name = "col1", col = 23, type = "Integer"),
              setColumn(name = "col2", col = 24, type = "Integer", isValueRequired = FALSE),
              setColumn(name = "textValue", col = 25, type = "Text", isValueRequired = FALSE),
              setColumn(name = "numericValue", col = 26, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "sheet", col = 27, type = "Text", isValueRequired = FALSE),
              setColumn(name = "withFX", col = 28, type = "Integer", isValueRequired = FALSE),
              setColumn(name = "style", col = 29, type = "Text", isValueRequired = FALSE),
              setColumn(name = "sheetSource", col = 30, type = "Text", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "correlationHealth",
            description = "correlation matrix health risk",
            sheet = "Correlation",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            isCorrelation = TRUE,
            columns = list(
              setColumn(name = "name", col = 14, type = "Text", characteristic = "Primary key"),
              setColumn(name = "Individual health", col = 15, type = "Numeric"),
              setColumn(name = "Collective compensation", col = 16, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "correlationLife",
            description = "correlation matrix life risk",
            sheet = "Correlation",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            isCorrelation = TRUE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "Mortality", col = 4, type = "Numeric"),
              setColumn(name = "Longevity", col = 5, type = "Numeric"),
              setColumn(name = "Disability", col = 6, type = "Numeric"),
              setColumn(name = "Reactivation", col = 7, type = "Numeric"),
              setColumn(name = "Costs", col = 8, type = "Numeric"),
              setColumn(name = "Lapses", col = 9, type = "Numeric"),
              setColumn(name = "Capital option", col = 10, type = "Numeric"),
              setColumn(name = "Cost BVG", col = 11, type = "Numeric"),
              setColumn(name = "Lapses BVG", col = 12, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "correlationRiskAggregation",
            description = "correlation matrix aggregation risks",
            sheet = "Correlation",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            isCorrelation = TRUE,
            columns = list(
              setColumn(name = "name", col = 18, type = "Text", characteristic = "Primary key"),
              setColumn(name = "market", col = 19, type = "Numeric"),
              setColumn(name = "life", col = 20, type = "Numeric"),
              setColumn(name = "health", col = 22, type = "Numeric"),
              setColumn(name = "nonlife", col = 21, type = "Numeric"),
              setColumn(name = "credit", col = 23, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "expectedFinancialResultTable",
            description = "expected financial result table",
            sheet = "Expected Financial Result",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "type", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "return", col = 3, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "exposure", col = 5, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, warning = "Negative")
            )
  )
  
  ,setTable(keyword = "maturitiesInterestRate",
            description = "projection times",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "time", col = 15, type = "Integer", characteristic = "Primary key"),
              setColumn(name = "projection", col = 16, type = "Text", isValueRequired = FALSE, isReplacementZero = TRUE)
            )
  )
  
  ,setTable(keyword = "initialFX",
            description = "exchange rates table",
            sheet = "Market Initial Values",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "from", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "to", col = 3, type = "Text", characteristic = "Primary key"),
              setColumn(name = "fx", col = 4, type = "Numeric", error = c("Negative", "Zero"))
            )
  )
  
  ,setTable(keyword = "initialInterestRate",
            description = "zero coupon rates table",
            sheet = "Market Initial Values",
            row = 6,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "currency", col = 6, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = as.character(1:50), col = 7, type = "Numeric", characteristic = "Transpose")
            )
  )
  
  ,setTable(keyword = "initialInterestRate1",
            description = "zero coupon rates table",
            sheet = "Market Initial Values",
            row = 6,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "currency", col = 6, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = paste0("Y", 1:50), col = 7, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "instrumentAsset",
            description = "asset prices table",
            sheet = "Asset Prices",
            row = 8,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "label", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "currency", col = 4, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = "value", col = 6, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, warning = "Negative")
            )
  )
  
  ,setTable(keyword = "instrumentAssetForward",
            description = "asset prices forward contracts table",
            sheet = "Forwards",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "contract", col = 2, type = "Text", characteristic = "Primary key", dataSelection = "Skip"),
              setColumn(name = "type", col = 4, type = "Text"),
              setColumn(name = "currency", col = 5, type = "Text", error = "notCurrency"),
              setColumn(name = "time", col = 6, type = "Integer", error = c("Negative", "Zero", "Larger50")),
              setColumn(name = "exposure", col = 7, type = "Numeric", warning = c("Zero"), error = "Negative"),
              setColumn(name = "price", col = 8, type = "Numeric", error = "Negative"),
              setColumn(name = "position", col = 9, type = "Text", error = "notLongShort")
            )
  )
  
  ,setTable(keyword = "instrumentDelta",
            description = "delta sensitivities table",
            sheet = "Delta Terms",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "unit", col = 4, type = "Text", error = "notUnit"),
              setColumn(name = "exposure", col = 12, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "instrumentFixedIncome",
            description = "fixed income table",
            sheet = "Fixed Income",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "currency", col = 2, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = "rating", col = 3, type = "Text", characteristic = "Primary key"),
              setColumn(name = "marketValue", col = 5, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, warning = "Negative"),
              setColumn(name = "spread", col = 6, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = as.character(1:50), col = 7, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, characteristic = "Transpose", warning = "Negative")
            )
  )
  
  ,setTable(keyword = "instrumentFX_Forward",
            description = "fx forward contracts table",
            sheet = "Forwards",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "contract", col = 11, type = "Text", characteristic = "Primary key", dataSelection = "Skip"),
              setColumn(name = "time", col = 13, type = "Integer", error = c("Negative", "Zero", "Larger50")),
              setColumn(name = "nominal", col = 14, type = "Numeric", error = "Negative"),
              setColumn(name = "rate", col = 15, type = "Numeric", error = "Negative"),
              setColumn(name = "foreign", col = 16, type = "Text"),
              setColumn(name = "position", col = 17, type = "Text", error = "notLongShort")
            )
  )
  
  ,setTable(keyword = "instrumentLiability",
            description = "insurance liability cashflows",
            sheet = "Insurance Cashflows",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "type", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "currency", col = 3, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = as.character(1:50), col = 5, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, characteristic = "Transpose", warning = "Negative")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsAdditionalCheck",
            description = "risk factors mapping table",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "type", col = 3, type = "Text"),
              setColumn(name = "name", col = 10, type = "Text"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text"),
              setColumn(name = "standalones", col = 13, type = "Text", characteristic = "Split", error = "notStandalone")
            )
  )
  ,setTable(keyword = "marketRiskFactorsAsset",
            description = "'asset price' risk factors",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "type", col = 3, type = "Text", filterValue = "^asset price$"),
              setColumn(name = "currency", col = 4, type = "Text", characteristic = "Primary key", error = "notCurrency"),
              setColumn(name = "label", col = 5, type = "Text", characteristic = "Primary key"),
              setColumn(name = "targetCurrency", col = 6, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "horizon", col = 7, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "rating", col = 8, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "description", col = 9, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "name", col = 10, type = "Text"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsCurrency",
            description = "'currency' risk factors",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "type", col = 3, type = "Text", filterValue = "^currency$"),
              setColumn(name = "currency", col = 4, type = "Text", characteristic = "Primary key", error = c("notCurrency")),
              setColumn(name = "label", col = 5, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "targetCurrency", col = 6, type = "Text", error = c("notCurrency")),
              setColumn(name = "horizon", col = 7, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "rating", col = 8, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "description", col = 9, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "name", col = 10, type = "Text"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsRate",
            description = "'rate' risk factors",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "type", col = 3, type = "Text", filterValue = "^rate$"),
              setColumn(name = "currency", col = 4, type = "Text", characteristic = "Primary key", error = c("notCurrency")),
              setColumn(name = "label", col = 5, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "targetCurrency", col = 6, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "horizon", col = 7, type = "Text", isValueRequired = FALSE, characteristic = "Primary key", error = c("notHorizon")),
              setColumn(name = "rating", col = 8, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "description", col = 9, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "name", col = 10, type = "Text"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsSpread",
            description = "'spread' risk factors",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "type", col = 3, type = "Text", filterValue = "^spread$"),
              setColumn(name = "currency", col = 4, type = "Text", characteristic = "Primary key", error = c("notCurrency")),
              setColumn(name = "label", col = 5, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "targetCurrency", col = 6, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "horizon", col = 7, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "rating", col = 8, type = "Text", characteristic = "Primary key"),
              setColumn(name = "description", col = 9, type = "Text", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "name", col = 10, type = "Text"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsDelta",
            description = "original risk factors (i.e. the risk factors that are included in the correlation matrix)",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text"),
              setColumn(name = "name", col = 10, type = "Text", characteristic = "Primary key"),
              setColumn(name = "scale", col = 11, type = "Numeric"),
              setColumn(name = "scaling", col = 12, type = "Text", filterValue = "^Yes$")
            )
  )
  
  ,setTable(keyword = "marketRiskFactorsStandalones",
            description = "standalone definition",
            sheet = "Market (Static)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "factorId", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "standalones", col = 13, type = "Text", characteristic = "Split", error = c("notStandalone"))
            )
  )
  
  ,setTable(keyword = "marketVolatility",
            description = "volatilty table",
            sheet = "Market (Dynamic)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "volatility", col = 4, type = "Numeric", characteristic = "Named vector", error = c("Zero", "Negative"))
            )
  )
  
  ,setTable(keyword = "MVM_CashFlowsLife",
            description = "MVM life cashflows",
            sheet = "Life (MVM)",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = as.character(0:49), col = 6, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, characteristic = "Transpose")
            )
  )
  
  ,setTable(keyword = "nonlifeCDF",
            description = "cdf for nonlife risk",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "x", col = 4, type = "Numeric", error = c("notStrictlyIncreasing")),
              setColumn(name = "cdf", col = 5, type = "Numeric", error = c("notContainOne", "notIncreasing", "Negative"))
            )
  )
  
  ,setTable(keyword = "nonlifeSimulation",
            description = "simulation vector for nonlife risk",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "simulation", col = 2, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "scenarioMacroEconomic",
            description = "macroeconomic scenario table",
            sheet = "Macroeconomic Scenarios",
            row = 6,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key", error = c("notRiskFactor")),
              setColumn(name = "unit", col = 3, type = "Text", error = "notUnit"),
              setColumn(name = "S1.1", col = 4, type = "Numeric"),
              setColumn(name = "S1.2", col = 5, type = "Numeric"),
              setColumn(name = "S1.3", col = 6, type = "Numeric"),
              setColumn(name = "S1.4", col = 7, type = "Numeric"),
              setColumn(name = "S4.1", col = 8, type = "Numeric"),
              setColumn(name = "S4.2", col = 9, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "scenarioSST",
            description = "scenario table",
            sheet = "Scenarios",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "label", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "name", col = 3, type = "Text"),
              setColumn(name = "effect", col = 7, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "probability", col = 8, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, error = c("Negative", "LargerOne"))
            )
  )
  
  ,setTable(keyword = "scenarioHealth",
            description = "health scenarios",
            sheet = "Health",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "label", col = 7, type = "Text", characteristic = "Primary key"),
              setColumn(name = "effect", col = 8, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "probability", col = 9, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, error = c("Negative", "LargerOne"))
            )
  )
  
  ,setTable(keyword = "creditRiskExposure",
            description = "credit risk table",
            sheet = "Credit Risk Basel",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            isDropEmptyRows = TRUE,
            columns = list(
              setColumn(name = "rating", col = 7, type = "Text"),
              setColumn(name = "weight", col = 8, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "weightedExposure", col = 12, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "creditRiskExposureReinsurance",
            description = "credit risk table",
            sheet = "Credit Risk Basel",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            isDropEmptyRows = TRUE,
            columns = list(
              setColumn(name = "class", col = 2, type = "Text", isValueRequired = FALSE, filterValue = "^A.7a$", characteristic = "AutoComplete"),
              setColumn(name = "rating", col = 7, type = "Text"),
              setColumn(name = "weight", col = 8, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "weightedExposure", col = 12, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "creditRiskExposureHypo",
            description = "credit risk table",
            sheet = "Credit Risk Basel",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            isDropEmptyRows = TRUE,
            columns = list(
              setColumn(name = "class", col = 2, type = "Text", isValueRequired = FALSE, filterValue = "(^A.8$)|(^B.3$)", characteristic = "AutoComplete"),
              setColumn(name = "rating", col = 7, type = "Text"),
              setColumn(name = "weight", col = 8, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE),
              setColumn(name = "weightedExposure", col = 12, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "sensitivityHealth",
            description = "health insurance sensitivities table",
            sheet = "Health",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "sensitivity", col = 5, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, characteristic = "Named vector", error = "Negative")
            )
  )
  
  ,setTable(keyword = "exposureLife",
            description = "life insurance sensitivities table",
            sheet = "Life",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "name", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "sensitivity", col = 5, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, characteristic = "Named vector")
            )
  )
  
  # Only to load the sheet
  ,setTable(keyword = "dummy1",
            description = "(cell from the balance sheet)",
            sheet = "SST Balance Sheet",
            row = 1,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 16, type = "Text", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "dummy2",
            description = "(cell from other data)",
            sheet = "Other Data",
            row = 1,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Text", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "configurationVersionId",
            description = "version of the configuraiton file",
            sheet = "Configuration",
            row = 2,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 26, type = "Numeric")
            )
  )
  
  ,setTable(keyword = "participationValue",
            description = "value for participation",
            sheet = "Asset Prices",
            row = 7,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 6, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, error = "Negative")
            )
  )
  
  ,setTable(keyword = "MVM_Health",
            description = "MVM (before the nhmr factor)",
            sheet = "General Inputs",
            row = 15,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, error = "Negative")
            )
  )
  ,setTable(keyword = "MVM_NonLife",
            description = "MVM (before the nhmr factor)",
            sheet = "General Inputs",
            row = 14,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, error = "Negative")
            )
  )
  
  ,setTable(keyword = "selectedBranch",
            description = "branch",
            sheet = "Intro",
            row = 11,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Text")
            )
  )
  ,setTable(keyword = "fileNameSuffix",
            description = "suffix for the output files",
            sheet = "Intro",
            row = 21,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Text", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "nonlifeMu",
            description = "lognormal parameter (mu) for nonlife",
            sheet = "Non Life",
            row = 18,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 7, type = "Numeric", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "nonlifeSigma",
            description = "lognormal parameter (sigma) for nonlife",
            sheet = "Non Life",
            row = 18,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 8, type = "Numeric", isValueRequired = FALSE, error = "Negative")
            )
  )
  
  ,setTable(keyword = "nonlifeType",
            description = "type of nonlife input",
            sheet = "Non Life",
            row = 5,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Text", error = "notNonLifeType")
            )
  )
  
  ,setTable(keyword = "companyName",
            description = "name of the insurance company",
            sheet = "Intro",
            row = 9,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Text")
            )
  )
  
  ,setTable(keyword = "referenceCurrency",
            description = "SST currency",
            sheet = "General Inputs",
            row = 7,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Text", error = "notCurrency")
            )
  )
  
  ,setTable(keyword = "expectedInsuranceResult",
            description = "expected insurance result",
            sheet = "General Inputs",
            row = 9,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE)
            )
  )
  
  ,setTable(keyword = "daughterValue",
            description = "value of the dauther company seen as participation by the mother",
            sheet = "General Inputs",
            row = 20,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE)
            )
  )
  
  
  ,setTable(keyword = "daughterScaling",
            description = "participation scaling factor (for the look-through approach)",
            sheet = "General Inputs",
            row = 21,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "daughterApplyLLPO",
            description = "indicator for the application of the LLPO (for the look-through approach)",
            sheet = "General Inputs",
            row = 22,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Logical", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "riskAsParticipation",
            description = "indicator for aggregating daughter market risk under the 'participation' risk factor",
            sheet = "General Inputs",
            row = 23,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Logical", isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "RTK_goingConcern",
            description = "going concern RBC",
            sheet = "RBC",
            row = 37,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Numeric", warning = c("Negative", "Zero"))
            )
  )
  ,setTable(keyword = "RTK_runOff",
            description = "run off RBC",
            sheet = "RBC",
            row = 46,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 5, type = "Numeric", warning = c("Negative", "Zero"))
            )
  )
  ,setTable(keyword = "additionalEffectsOnTC",
            description = "additional effects on the target capital",
            sheet = "General Inputs",
            row = 8,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", isValueRequired = FALSE, isReplacementZero = TRUE, warning = "Negative")
            )
  )
  
  ,setTable(keyword = "expectedFinancialResultFactor",
            description = "additional effects on the target capital",
            sheet = "General Parameters",
            row = 6,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "param_creditRiskFactor",
            description = "credit risk",
            sheet = "General Parameters",
            row = 7,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "param_costOfCapital",
            description = "cost of capital",
            sheet = "General Parameters",
            row = 8,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "param_participationVolatility",
            description = "volatility of immaterial participations",
            sheet = "General Parameters",
            row = 10,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "param_nhmrFactor",
            description = "additional effects on the target capital",
            sheet = "General Parameters",
            row = 9,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "migrationMatrix",
            description = "migration matrix",
            sheet = "Credit Risk Parameters",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            
            columns = list(
              setColumn(name = "category", col = 5, type = "Integer", characteristic = "Primary key"),
              setColumn(name = paste0(1:9), col = 6, type = "Numeric", error = "Negative")
            )
  )
  ,setTable(keyword = "spreadCurve",
            description = "cumulating spread curve",
            sheet = "Credit Risk Parameters",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "category", col = 16, type = "Integer", characteristic = "Primary key"),
              setColumn(name = "curve", col = 17, type = "Numeric", error = "notIncreasing", warning = "Negative")
            )
  )
  ,setTable(keyword = "mappingLGD",
            description = "mapping LGD",
            sheet = "Credit Risk Parameters",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = FALSE,
            columns = list(
              setColumn(name = "class", col = 2, type = "Text", characteristic = "Primary key"),
              setColumn(name = "LGD", col = 3, type = "Numeric", error = c("Negative", "LargerOne"))
            )
  )
  # ,setTable(keyword = "mappingCategory",
  #           description = "mapping for Basel categories",
  #           sheet = "Parameters",
  #           row = 20,
  #           isValue = FALSE,
  #           isEmptyAllowed = FALSE,
  #           isCorrelation = FALSE,
  #           columns = list(
  #             setColumn(name = "class", col = 5, type = "Text", characteristic = "Primary key"),
  #             setColumn(name = paste0(1:8), col = 6, type = "Numeric", error = "Negative", characteristic = "Transpose")
  #           )
  # )
  
  ,setTable(keyword = "portfolioCreditRisk",
            description = "portfolio without coupons",
            sheet = "Credit Risk Merton",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "positionId", col = 2, type = "Text"),
              setColumn(name = "positionName", col = 3, type = "Text"),
              setColumn(name = "includeInCreditRisk", col = 4, type = "Logical", filterValue = "^Yes$"), #Filter is applied before conversion to logical
              setColumn(name = "counterpartyId", col = 5, type = "Text"),
              setColumn(name = "counterpartyName", col = 6, type = "Text"),
              setColumn(name = "rating", col = 7, type = "Integer", error = "notRating"),
              setColumn(name = "basel", col = 9, type = "Text", error = "notLGDClass"),
              setColumn(name = "migration", col = 10, type = "Logical"),
              setColumn(name = "currency", col = 11, type = "Text", error = "notCurrency"),
              setColumn(name = "scalingCF", col = 12, type = "Numeric", error =  c("Negative", "Zero", "LargerOne"), isValueRequired = FALSE),
              setColumn(name = "scalingLGD", col = 13, type = "Numeric", error = c("Negative", "Zero", "LargerOne"), isValueRequired = FALSE),
              setColumn(name = "marketValue", col = 14, type = "Numeric", error = "Negative"),
              setColumn(name = paste0("Y", 1:50), col = 15, type = "Numeric", isValueRequired = FALSE, error = "Negative")
            )
  )
  ,setTable(keyword = "portfolioCreditRiskCheck",
            description = "portfolio without coupons",
            sheet = "Credit Risk Merton",
            row = 7,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "positionId", col = 2, type = "Text"),
              setColumn(name = "positionName", col = 3, type = "Text"),
              setColumn(name = "includeInCreditRisk", col = 4, type = "Logical"),
              setColumn(name = "counterpartyId", col = 5, type = "Text"),
              setColumn(name = "counterpartyName", col = 6, type = "Text"),
              setColumn(name = "rating", col = 7, type = "Integer", error = "notRating"),
              setColumn(name = "basel", col = 9, type = "Text"),
              setColumn(name = "migration", col = 10, type = "Logical"),
              setColumn(name = "currency", col = 11, type = "Text", error = "notCurrency"),
              setColumn(name = "marketValue", col = 14, type = "Numeric", error = "Negative"),
              setColumn(name = paste0("Y", 1:50), col = 15, type = "Numeric", isValueRequired = FALSE, error = "Negative")
            )
  )
  
  ,setTable(keyword = "captiveCY_deterministic",
            description = "captive current year parameters",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "branch", col = 10, type = "Text", characteristic = "Primary key"),
              setColumn(name = "branchType", col = 11, type = "Text", filterValue = "^Maximum possible loss$"),
              setColumn(name = "maximumPossibleLoss", col = 12, type = "Numeric", warning = c("Negative", "Zero")),
              setColumn(name = "expectedLoss", col = 13, type = "Numeric", warning = c("Negative", "Zero")),
              setColumn(name = "normalLossNumber", col = 14, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "normalLossSize", col = 15, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "normalLossSigma", col = 16, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "largeLossNumber", col = 17, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "largeLossThreshold", col = 18, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "largeLossShape", col = 19, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "AAL", col = 20, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "EEL", col = 21, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "AAD", col = 22, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "EED", col = 23, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "QS", col = 24, type = "Numeric", isValueRequired = FALSE, error = "notEmpty")
            )
  )
  
  ,setTable(keyword = "captiveCY_stochastic",
            description = "captive current year parameters",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "branch", col = 10, type = "Text", characteristic = "Primary key"),
              setColumn(name = "branchType", col = 11, type = "Text", filterValue = "^Ground-up loss$"),
              setColumn(name = "maximumPossibleLoss", col = 12, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "expectedLoss", col = 13, type = "Numeric", isValueRequired = FALSE, error = "notEmpty"),
              setColumn(name = "normalLossNumber", col = 14, type = "Numeric", error = c("Negative", "Zero", "notSmallValue"), isValueRequired = FALSE),
              setColumn(name = "normalLossSize", col = 15, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "normalLossSigma", col = 16, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "largeLossNumber", col = 17, type = "Numeric", error = c("Negative", "Zero", "notSmallValue"), isValueRequired = FALSE),
              setColumn(name = "largeLossThreshold", col = 18, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "largeLossShape", col = 19, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "AAL", col = 20, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "EEL", col = 21, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "AAD", col = 22, type = "Numeric", error = c("Negative"), isReplacementZero = TRUE, isValueRequired = FALSE),
              setColumn(name = "EED", col = 23, type = "Numeric", error = c("Negative"), isReplacementZero = TRUE, isValueRequired = FALSE),
              setColumn(name = "QS", col = 24, type = "Numeric", error = c("Negative", "Zero", "LargerOne"), isValueRequired = FALSE)
            )
  )
  
  ,setTable(keyword = "captiveCY",
            description = "captive current year parameters",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "branch", col = 10, type = "Text", characteristic = "Primary key"),
              setColumn(name = "branchType", col = 11, type = "Text", error = "notCaptiveBranchType"),
              setColumn(name = "maximumPossibleLoss", col = 12, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "expectedLoss", col = 13, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "normalLossNumber", col = 14, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "normalLossSize", col = 15, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "normalLossSigma", col = 16, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "largeLossNumber", col = 17, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "largeLossThreshold", col = 18, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "largeLossShape", col = 19, type = "Numeric", isValueRequired = FALSE),
              setColumn(name = "AAL", col = 20, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "EEL", col = 21, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE),
              setColumn(name = "AAD", col = 22, type = "Numeric", error = c("Negative"), isReplacementZero = TRUE, isValueRequired = FALSE),
              setColumn(name = "EED", col = 23, type = "Numeric", error = c("Negative"), isReplacementZero = TRUE, isValueRequired = FALSE),
              setColumn(name = "QS", col = 24, type = "Numeric", error = c("Negative", "Zero"), isValueRequired = FALSE)
            )
  )  
  
  ,setTable(keyword = "captivePY",
            description = "captive previous year parameters",
            sheet = "Non Life",
            row = 18,
            isValue = FALSE,
            isEmptyAllowed = TRUE,
            columns = list(
              setColumn(name = "branch", col = 26, type = "Text", characteristic = "Primary key"),
              setColumn(name = "reserve", col = 27, type = "Numeric", error = "Negative", warning = "Zero"),
              setColumn(name = "cov", col = 28, type = "Numeric", error = c("Negative", "Zero"))
            )
  )
  
  ,setTable(keyword = "useNewCreditRiskModel",
            description = "usage of new (field-test) credit risk model",
            sheet = "General Inputs",
            row = 24,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 4, type = "Logical")
            )
  )
  ,setTable(keyword = "rho",
            description = "correlation between idiosyncratic and systematic risks",
            sheet = "Credit Risk Parameters",
            row = 7,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 21, type = "Numeric", error = c("Negative", "LargerOne"))
            )
  )
  ,setTable(keyword = "corr",
            description = "correlation between Basel3 Term and Stochastic Bond model",
            sheet = "Credit Risk Parameters",
            row = 8,
            isValue = TRUE,
            columns = list(
              setColumn(name = "none", col = 21, type = "Numeric", error = c("Negative", "LargerOne"))
            )
  )
)



config <- rbindlist(TemplateConfig)
fwrite(config, "inst/extdata/wb.csv")

addCurrentVersion <- function(){
  data.table(content = "addCurrentVersion", row1 = 0, row2 = NA, col1 = 0, col2 = NA, textValue = "", numericValue = as.character(round(as.numeric(Sys.time())),0), sheet = "", withFX = NA, style = NA, sheetSource = NA)
}

addWorksheet <- function(sheet, rowMax, colMax){
  data.table(content = "addWorksheet", row1 = rowMax, row2 = NA, col1 = colMax, col2 = NA, textValue = "", numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
}

addText <- function(sheet, row, col, textValue){
  data.table(content = "addText", row1 = row, row2 = NA, col1 = col, col2 = NA, textValue = textValue, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
}

addTextFromExcel <- function(sheet, row, col, sheetSource, rowSource, colSource){
  data.table(content = "addTextFromExcel", row1 = row, row2 = rowSource, col1 = col, col2 = colSource, textValue = NA, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = sheetSource)
}

addNumericFromExcel <- function(sheet, row, col, sheetSource, rowSource, colSource, withFX){
  data.table(content = "addNumericFromExcel", row1 = row, row2 = rowSource, col1 = col, col2 = colSource, textValue = NA, numericValue = "", sheet = sheet, withFX = withFX, style = NA, sheetSource = sheetSource)
}

addNumericFromKeyword <- function(sheet, row, col, keyword, withFX){
  data.table(content = "addNumericFromKeyword", row1 = row, row2 = NA, col1 = col, col2 = NA, textValue = keyword, numericValue = "", sheet = sheet, withFX = withFX, style = NA, sheetSource = NA)
}

writeValues <- function(sheet, rowMin, rowMax, colMin, colMax, isNumeric){
  style <- ifelse(isNumeric, "numContent", "textContent")
  data.table(content = "writeValues", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = "", numericValue = "", sheet = sheet, withFX = NA, style = style, sheetSource = NA)
}

addBaseFont <- function(sheet, font, fontsize){
  data.table(content = "addBaseFont", row1 = 0, row2 = NA, col1 = 0, col2 = NA, textValue = font, numericValue = as.character(fontsize), sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
}

addStyle <- function(sheet, style, rowMin, rowMax, colMin, colMax, stack){
  stack <- ifelse(stack, 1, 0)
  data.table(content = "addStyle", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = "", numericValue = "", sheet = sheet, withFX = stack, style = style, sheetSource = NA)
}

addColWidth <- function(sheet, col, width){
  data.table(content = "addColWidth", row1 = 0, row2 = NA, col1 = col, col2 = NA, textValue = "", numericValue = width, sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
}

addFormat <- function(sheet, rowMin, rowMax, colMin, colMax, format){
  data.table(content = "addFormat", row1 = rowMin, row2 = rowMax, col1 = colMin, col2 = colMax, textValue = format, numericValue = "", sheet = sheet, withFX = NA, style = NA, sheetSource = NA)
}

configFDS <- rbindlist(list(
addCurrentVersion(),
addWorksheet("Fundamental_Data", 300, 6),
addText("Fundamental_Data", row = FDSLabel$row, col = FDSLabel$col, textValue = FDSLabel$field),
addNumericFromKeyword("Fundamental_Data", row = 14, col = 3, keyword = "FX_to_CHF", withFX = 0),
addNumericFromKeyword("Fundamental_Data", row = FDSValues$row, col = 3, keyword = FDSValues$field, withFX = 0),
addNumericFromKeyword("Fundamental_Data", row = FDSValues$row, col = 4, keyword = FDSValues$field, withFX = FDSValues$withFX),
addNumericFromExcel(sheet = "Fundamental_Data", row = FDSImport$row, col = 3, sheetSource = FDSImport$sheet, rowSource = FDSImport$row1, colSource = FDSImport$col, withFX = 0),
addNumericFromExcel(sheet = "Fundamental_Data", row = FDSImport$row, col = 4, sheetSource = FDSImport$sheet, rowSource = FDSImport$row1, colSource = FDSImport$col, withFX = FDSImport$withFX),
addTextFromExcel(sheet = "Fundamental_Data", row = 9, col = 3, sheetSource = "Intro", rowSource = 9, colSource = 5),
addTextFromExcel(sheet = "Fundamental_Data", row = 10, col = 3, sheetSource = "Intro", rowSource = 11, colSource = 5),
addTextFromExcel(sheet = "Fundamental_Data", row = 5, col = 3, sheetSource = "RBC", rowSource = 5, colSource = 5),
addTextFromExcel(sheet = "Fundamental_Data", row = 13, col = 3, sheetSource = "General Inputs", rowSource = 7, colSource = 4),
writeValues("Fundamental_Data", rowMin = 1, rowMax = 227, colMin = 2, colMax = 6, isNumeric = FALSE),
writeValues("Fundamental_Data", rowMin = 14, rowMax = 227, colMin = 3, colMax = 4, isNumeric = TRUE),
addBaseFont("Fundamental_Data", font = "Arial", fontsize = 10),
addStyle("Fundamental_Data", style = "commentStyle", rowMin = commentStyle$row1, rowMax = commentStyle$row2, colMin = 6, colMax = 6, stack = 0),
addStyle("Fundamental_Data", style = "headerStyle", rowMin = c(8, 12), rowMax = c(8, 12), colMin = 2, colMax = 3, stack = 0),
addStyle("Fundamental_Data", style = "headerStyle", rowMin = headerStyle$row, rowMax = headerStyle$row, colMin = 2, colMax = 4, stack = 0),
addStyle("Fundamental_Data", style = "headerStyleCentering", rowMin = 5, rowMax = 5, colMin = c(3, 6), colMax = c(4, 6), stack = 0),
addStyle("Fundamental_Data", style = "topHeaderStyle", rowMin = 1, rowMax = 1, colMin = 2, colMax = 2, stack = 0),
addStyle("Fundamental_Data", style = "boldStyle", rowMin = boldStyle$row, rowMax = boldStyle$row, colMin = 2, colMax = 2, stack = 0),
addStyle("Fundamental_Data", style = "lightGridStyle", rowMin = c(9, 13), rowMax = c(10, 14), colMin = 2, colMax = 3, stack = 1),
addStyle("Fundamental_Data", style = "lightGridStyle", rowMin = lightGridStyle$row1, rowMax = lightGridStyle$row2, colMin = 2, colMax = 4, stack = 1),
addStyle("Fundamental_Data", style = "whiteGridStyle", rowMin = 16, rowMax = 16, colMin = 2, colMax = 4, stack = 1),
addColWidth("Fundamental_Data", col = 1:6, width = c("7.64", "95.18", "25.18", "25.18", "3.82", "54.55")),
addFormat("Fundamental_Data", rowMin = 1, rowMax = 227, colMin = 3, colMax = 4, format = "0.0"),
addFormat("Fundamental_Data", rowMin = 113, rowMax = 113, colMin = 3, colMax = 4, format = "0%")
))

fwrite(configFDS, "inst/extdata/wbFDS.csv")