context("Reordering")


test_that("getOrdering", {
  # Ordering
  main <- data.table(market = c(1,2,3), b = c(20,10,30), c = c(55,12,11))
  ranks <- data.table(market = c(1,2,3), b = c(3,2,1), c = c(2,3,1))
  
  ordering <- getOrdering(ranks = ranks, main = main)
  ordering_result <- data.table(market = c(1L,2L,3L), b = c(3L,1L,2L), c = c(2L,1L,3L))
  expect_identical(ordering, ordering_result)
  
  # Ensure to have the same order as the sstTool for market
  main <- data.table(market = c(1,2,3), b = c(20,10,30), c = c(55,12,11))
  ranks <- data.table(market = c(1,2,3), b = c(3,2,1), c = c(2,3,1))
  
  ordering <- getOrdering(ranks = ranks[c(2,1,3)], main = main)
  ordering_result <- data.table(market = c(1L,2L,3L), b = c(3L,1L,2L), c = c(2L,1L,3L))
  expect_identical(ordering, ordering_result)
})



# test_that("getSimulationReordering",{
#   sim <- list(
#     market = data.table(all = c(1,2,3), equity = c(1.5, 2, 0)),
#     participation = data.table(all = c(10, 4, 3)),
#     life = data.table(all = c(3, 2, 1))
#   )
#   # Reordering of simulations
#   ordering <- data.table(market = c(3, 2, 1), participation = c(2, 3, 1), life = c(1, 2, 3))
#   
#   result_expected <- data.table(market.all = c(3,2,1), market.equity = c(0,2,1.5), participation.all = c(4,3,10), 
#                                 life.all = c(3, 2, 1), simulation_id = 1:3)
#   result <- getSimulationReordering(sim, ordering)
#   expect_identical(result, result_expected)
#   
#   # Reordering of risk factors (wih NULL values)
#   sim <- list(
#     market = data.table(all = c(1,2,3), equity = c(1.5, 2, 0)),
#     participation = NULL,
#     life = data.table(all = c(3, 2, 1)),
#     health = NULL
#   )
#   ordering <- data.table(market = c(1,2,3), participation = c(2, 3, 1), life = c(1, 2, 3), health = c(2,1,3))
#   
#   result_expected <- data.table(market.all = c(1,2,3), market.equity = c(1.5, 2, 0), 
#                                 life.all = c(3, 2, 1), simulation_id = 1:3)
#   result <- getSimulationReordering(sim, ordering)
#   expect_identical(result, result_expected)
# })





# test_that("simulate.Reordering",{
#   nsim <- 10
#   seed <- 1
#   set.seed(89835) # seed for reordering with market seed = 1
#   mu <- c(0,0)
#   Sigma <- matrix(c(1,0.99,0.99,1), ncol=2)
#   object <- list(mu=mu, Sigma=Sigma)
#   A <- data.table(MASS::mvrnorm(n = nsim, mu = mu, Sigma = Sigma))
#   print(A)
#   for (j in names(A)){
#     set(A, j = j, value = frank(A[[j]], ties.method = "first"))
#   }
#   
#   B <- simulate.Reordering(object, nsim, seed)
#   expect_identical(A, B)
# })


