context("Simulate")

addNullRF <-function(sim){
  list(sim = sim, RF = NULL)
}



# test_that("Participation simulation", {
#   seed <- getSeed(1, "Participation")
# 
#   # Participation
#   sim <- simulate.ParticipationRisks(object = list(exposure = 1.1, sd = 2), nsim = 5, seed = 1)
#   set.seed(seed)
#   sim_result <- data.table(all = 1.1 * expm1(stats::rnorm(n = 5, sd = 2) - 0.5 * (2^2)))
#   expect_equal(sim, addNullRF(sim_result))
# })


test_that("Life simulation", {
  # Life and health
  nm <- c("RF1", "RF2")
  object <- list(correlation = matrix(c(1, 0.2, 0.2, 1), 2, dimnames = list(nm, nm)), volatility = c(RF1 = 1, RF2 = 1.5))

  seed <- getSeed(1, "Life")

  sim <- simulate.lifeModule(object = object, nsim = 10, seed = 1)
  set.seed(seed)
  sim_result <- simulationMultivariate(object$correlation, object$volatility, 10)
  expect_identical(sim, sim_result)
})

